/*
   scalarprod_gm - caluclate and time the scalar product
   
   EEE4084F prepated by S. Winberg 2017
*/

#include <iostream>
#include <stdlib.h>
#include "Timer.h"

float random_f ()
{
	return (float)rand()/(float)(RAND_MAX);
}

/** scalarprod : populates two vectors a and b, which are
     both of size n, with random values and the calculates
	 the product of both vectors. */
float scalarprod (float* a, float* b, int n)
{
	unsigned i;
	// get initial tick value
	tic(); 

	// Do processing ...
	// provide random seed
 	srand((unsigned int)time(NULL));
	// first initialize the vectors
  	for (i=0; i<n; i++) {
 		a[i] = random_f(); 
		b[i] = random_f(); 
		}
	float sum = 0.0f;
	for (i=0; i<n; i++) {
		sum = sum + (a[i] * b[i]);
		}
	// get the time elapsed
	double t1 = toc();  // get final tick value
	std::cout << "scalarprod n=" << n << " took " << t1 << " ms\n";
        return sum;
}


int main(int argc, char** argv) {
	#define N 200000
	float x[N], y[N];
	float z = scalarprod(x,y,N);
	std::cout << "x * y = " << z << std::endl;
	return 0;
}

